# -*- coding: utf-8 -*-

"""
pqapiv2

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""


class FxObject(object):

    """Implementation of the '_fxObject' model.

    Currency conversion object details

    Attributes:
        destination_amount (float): Amount transferred to the destination
        destination_currency (CurrencyTypesEnum): Currency code type for the
            object
        source_amount (float): Amount of the transfer in the specified
            currency.
        source_currency (CurrencyTypesEnum): Currency code type for the
            object
        rate (float): Exchange rate

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "destination_amount": 'destinationAmount',
        "destination_currency": 'destinationCurrency',
        "source_amount": 'sourceAmount',
        "source_currency": 'sourceCurrency',
        "rate": 'rate'
    }

    def __init__(self,
                 destination_amount=None,
                 destination_currency=None,
                 source_amount=None,
                 source_currency=None,
                 rate=None):
        """Constructor for the FxObject class"""

        # Initialize members of the class
        self.destination_amount = destination_amount
        self.destination_currency = destination_currency
        self.source_amount = source_amount
        self.source_currency = source_currency
        self.rate = rate

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary
        destination_amount = dictionary.get('destinationAmount')
        destination_currency = dictionary.get('destinationCurrency')
        source_amount = dictionary.get('sourceAmount')
        source_currency = dictionary.get('sourceCurrency')
        rate = dictionary.get('rate')

        # Return an object of this model
        return cls(destination_amount,
                   destination_currency,
                   source_amount,
                   source_currency,
                   rate)
