# -*- coding: utf-8 -*-

"""
pqapiv2

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""


class MonetaryFormatted(object):

    """Implementation of the '_monetaryFormatted' model.

    Object representing monies, including currency, decimal, and formatted
    amounts

    Attributes:
        formatted_amount (string): Formatted monetary amount
        amount (float): Amount of the transfer in the specified currency.
        currency (CurrencyTypesEnum): Currency code type for the object

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "amount": 'amount',
        "currency": 'currency',
        "formatted_amount": 'formattedAmount'
    }

    def __init__(self,
                 amount=None,
                 currency=None,
                 formatted_amount=None):
        """Constructor for the MonetaryFormatted class"""

        # Initialize members of the class
        self.formatted_amount = formatted_amount
        self.amount = amount
        self.currency = currency

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary
        amount = dictionary.get('amount')
        currency = dictionary.get('currency')
        formatted_amount = dictionary.get('formattedAmount')

        # Return an object of this model
        return cls(amount,
                   currency,
                   formatted_amount)
